<?php

//This implementation uses OAuth, from the debian package liboauth-php.

require_once('OAuth.php');
$req_url = 'http://www.openstreetmap.org/oauth/request_token';
$authurl = 'http://www.openstreetmap.org/oauth/authorize';
$acc_url = 'http://www.openstreetmap.org/oauth/access_token';
$api_url = 'http://www.openstreetmap.org/api/0.6/user/details';

$useLocalhost = 0;
if($useLocalhost)
{
	$conskey = 'OB8yWaQKoKct8wj3n5NFw';
	$conssec = 'FCstYwLREpbqvkQjNjwaocnTmGfTlbBqKsryENyaW4';
}
else
{
	$conskey = '3hb6g4A3yyiOqU2UXYM5w';
	$conssec = 'yebwU1iofe1Au8Wb746mL3i4Q9hWLzBPhKuNRLeWU';
}
$sig_method = new OAuthSignatureMethod_HMAC_SHA1();

if(!isset($_SESSION['oauth_state']))
	$_SESSION['oauth_state'] = 0; //Initialise state
if($_SESSION['oauth_state']==1 and !isset($_GET['oauth_token']))
	$_SESSION['oauth_state'] = 0;

http://localhost/extralicenses/

if(!class_exists('OAuthException') or !class_exists('OAuthConsumer'))
		die("OAuth not installed on this server. On Debian/Ubuntu try \"apt-get install liboauth-php\".");


$test_consumer = new OAuthConsumer($conskey, $conssec, NULL);


if(!isset($_SESSION['display_name']) or !isset($_SESSION['user_id']))
{
try {

//***** Request Token *********
//echo $_SESSION['oauth_state'];
if(!isset($_GET['oauth_token']) && !$_SESSION['oauth_state'])
{
	$params = array();
	//parse_str($parsed['query'], $params);

	$req_req = OAuthRequest::from_consumer_and_token($test_consumer, NULL, "GET", $req_url, $params);
	$req_req->sign_request($sig_method, $test_consumer, NULL);
	if (0) {
	  Header('Content-type: text/plain');
	  print "request url: " . $req_req->to_url(). "\n";
	  print_r($req_req);
	}
	$_SESSION['oauth_state'] = 1;
	
	parse_str(file_get_contents($req_req), $tokenRet);
	//print_r($tokenRet);
	if(!isset($tokenRet['oauth_token'])) 
		die("Could not retrieve oauth_token from server.");

	$_SESSION['secret'] = $tokenRet['oauth_token_secret'];

	header('Location: '.$authurl.'?oauth_token='.$tokenRet['oauth_token']);
	exit;
} 

//********** Get Access Token *********
if($_SESSION['oauth_state']==1 and isset($_GET['oauth_token']))
{
	//$parsed = parse_url($endpoint);
	$params = array();
	//parse_str($parsed['query'], $params);

	$test_token = new OAuthConsumer($_GET['oauth_token'], $_SESSION['secret']);
	$acc_req = OAuthRequest::from_consumer_and_token($test_consumer, $test_token, 
		"GET", $acc_url, $params);
	$acc_req->sign_request($sig_method, $test_consumer, $test_token);
	if (0) {
		Header('Content-type: text/plain');
		print "request url: " . $acc_req->to_url() . "\n";
		print_r($acc_req);
		exit;
	}

	parse_str(file_get_contents($acc_req), $getAccessTokenRet);
	//print_r($getAccessTokenRet);
	if(isset($getAccessTokenRet['oauth_token']) and isset($getAccessTokenRet['oauth_token_secret']))
	{
		$_SESSION['oauth_token'] = $getAccessTokenRet['oauth_token'];
		$_SESSION['secret'] = $getAccessTokenRet['oauth_token_secret'];
		$_SESSION['oauth_state'] = 2;
	}
}

if($_SESSION['oauth_state']==2)
{
	$params = array();
	$test_token = new OAuthConsumer($_SESSION['oauth_token'], $_SESSION['secret']);
	$api_req = OAuthRequest::from_consumer_and_token($test_consumer, $test_token, 
		"GET", $api_url, $params);
	$api_req->sign_request($sig_method, $test_consumer, $test_token);

	$prefs = file_get_contents($api_req);

	$xml = new SimpleXMLElement($prefs);
	if(!isset($xml->user[0]['display_name'])) die("Display name not set");
	if(!isset($xml->user[0]['id'])) die("User ID not set");

	$_SESSION['display_name'] = (string)$xml->user[0]['display_name'];
	$_SESSION['user_id'] = (int)($xml->user[0]['id']);
}

} 
catch(OAuthException $E) 
{
	unset($_SESSION['oauth_state']);
	echo "<h1>OAuth Error</h1>";
	print_r($E);
	die();
}
}

if(!isset($_SESSION['display_name']) or !isset($_SESSION['user_id']))
{
	unset($_SESSION['oauth_state']);
	echo "<h1>OAuth Error</h1>";
	die();	
}
?>
