<?php

//This implementation uses OAuth, from pecl. http://pecl.php.net/package/oauth

$req_url = 'http://www.openstreetmap.org/oauth/request_token';
$authurl = 'http://www.openstreetmap.org/oauth/authorize';
$acc_url = 'http://www.openstreetmap.org/oauth/access_token';
$api_url = 'http://www.openstreetmap.org/api/0.6/user/details';
$conskey = '3hb6g4A3yyiOqU2UXYM5w';
$conssec = 'yebwU1iofe1Au8Wb746mL3i4Q9hWLzBPhKuNRLeWU';

if(!class_exists("OAuth"))
{
	die("OAuth not installed on this server. Do \"pecl install oauth\".");
}

// In state=1 the next request should include an oauth_token.
// If it doesn't go back to 0
if(!isset($_GET['oauth_token']) && $_SESSION['oauth_state']==1) 
	$_SESSION['oauth_state'] = 0;

if(!isset($_SESSION['display_name']) or !isset($_SESSION['user_id']))
{
try {
	$oauth = new OAuth($conskey,$conssec,OAUTH_SIG_METHOD_HMACSHA1,OAUTH_AUTH_TYPE_URI);
	$oauth->enableDebug();

	if(!isset($_GET['oauth_token']) && !$_SESSION['oauth_state']) {
	    $request_token_info = $oauth->getRequestToken($req_url);
	    $_SESSION['secret'] = $request_token_info['oauth_token_secret'];
	    $_SESSION['oauth_state'] = 1;
	    header('Location: '.$authurl.'?oauth_token='.$request_token_info['oauth_token']);
	    exit;
	} 
	else 
	if($_SESSION['oauth_state']==1) {
		$oauth->setToken($_GET['oauth_token'],$_SESSION['secret']);
		$access_token_info = $oauth->getAccessToken($acc_url);
		$_SESSION['oauth_state'] = 2;
		$_SESSION['token'] = $access_token_info['oauth_token'];
		$_SESSION['secret'] = $access_token_info['oauth_token_secret'];
	} 

	$oauth->setToken($_SESSION['token'],$_SESSION['secret']);	
	$oauth->fetch($api_url);	
	$prefs = $oauth->getLastResponse();
	//print_r($prefs );
	$xml = new SimpleXMLElement($prefs);
	
	if(!isset($xml->user[0]['display_name'])) die("Display name not set");
	if(!isset($xml->user[0]['id'])) die("User ID not set");

	//echo $xml->user[0]['display_name'].$xml->user[0]['id'];
	$_SESSION['display_name'] = (string)$xml->user[0]['display_name'];
	$_SESSION['user_id'] = (int)($xml->user[0]['id']);
	
} 
catch(OAuthException $E) 
{
	unset($_SESSION['oauth_state']);
	echo "<h1>OAuth Error</h1>";
	print_r($E);
	die();
}
}

?>
